; -*- mode: emacs-lisp; -*-
;;; ciao-config.el --- Configuration parameters for this installation

;; Copyright (C) 1986-2012 Free Software Foundation, Inc. and
;; M. Hermenegildo and others (herme@fi.upm.es, UPM-CLIP, Spain).

;; This file is not part of GNU Emacs.

;; This file is free software; you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 3, or (at your option)
;; any later version.

;; This file is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with GNU Emacs; see the file COPYING.  If not, write to the
;; Free Software Foundation, Inc., 59 Temple Place - Suite 330,
;; Boston, MA 02111-1307, USA.

;; In emacs this is done most reliably by setting INFOPATH (done in
;; Ciao installation).  xemacs does need it for finding the Ciao
;; manuals (does not seem to read INFOPATH). 

(defvar ciao-bin-dir "/usr/bin"
  "Where the actual Ciao binaries are.")

(defvar ciao-config 
  `(:version "1.15.0"
    ;; Paths
    :bin-dir "/usr/bin"
    :real-lib-dir "/usr/lib/ciao/ciao-1.15"
    :lpdoc-lib-dir "/usr/lib/lpdoc/lpdoc-3.0"
    :lpdoc-dir "/usr/share/doc/CiaoDE/"
    ;; Manuals
    :ciao-manual-base "ciao-1.15.0"
    :ciaopp-manual-base "ciaopp"
    :lpdoc-manual-base "lpdoc-3.0.0"
    ;; Binaries
    :ciaosh-bin ,(concat ciao-bin-dir "/ciao-1.15")    
    :ciaopp-bin ,"ciaopp"
    :lpdoc-bin ,(concat ciao-bin-dir "/lpdoc-3.0")
    :plindent-bin ,(concat ciao-bin-dir "/plindent-1.15")
    ))

(defun ciao-get-config (prop)
  "Obtain configuration property `prop'"
  (plist-get ciao-config prop))


;; Provide ourselves:

(provide 'ciao-config)

;;; ciao-config.el ends here

